<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for TxConnectDispatcherDetails StructType
 * @subpackage Structs
 */
class TxConnectDispatcherDetails extends TxConnectDispatcherStrategy
{
    /**
     * The Inactive
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $Inactive;
    /**
     * The PersonalCommunication
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfPersonalCommunicationInsert
     */
    public $PersonalCommunication;
    /**
     * The PersonID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $PersonID;
    /**
     * The PersonExternalCode
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $PersonExternalCode;
    /**
     * The Language
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Language;
    /**
     * The Description
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Description;
    /**
     * The Email
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Email;
    /**
     * The Phone
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Phone;
    /**
     * The Password
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Password;
    /**
     * The UserProfile
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\UserProfile
     */
    public $UserProfile;
    /**
     * The RightsProfile
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\RightsProfile
     */
    public $RightsProfile;
    /**
     * Constructor method for TxConnectDispatcherDetails
     * @uses TxConnectDispatcherDetails::setInactive()
     * @uses TxConnectDispatcherDetails::setPersonalCommunication()
     * @uses TxConnectDispatcherDetails::setPersonID()
     * @uses TxConnectDispatcherDetails::setPersonExternalCode()
     * @uses TxConnectDispatcherDetails::setLanguage()
     * @uses TxConnectDispatcherDetails::setDescription()
     * @uses TxConnectDispatcherDetails::setEmail()
     * @uses TxConnectDispatcherDetails::setPhone()
     * @uses TxConnectDispatcherDetails::setPassword()
     * @uses TxConnectDispatcherDetails::setUserProfile()
     * @uses TxConnectDispatcherDetails::setRightsProfile()
     * @param bool $inactive
     * @param \ArrayType\ArrayOfPersonalCommunicationInsert $personalCommunication
     * @param string $personID
     * @param string $personExternalCode
     * @param string $language
     * @param string $description
     * @param string $email
     * @param string $phone
     * @param string $password
     * @param \StructType\UserProfile $userProfile
     * @param \StructType\RightsProfile $rightsProfile
     */
    public function __construct($inactive = null, \ArrayType\ArrayOfPersonalCommunicationInsert $personalCommunication = null, $personID = null, $personExternalCode = null, $language = null, $description = null, $email = null, $phone = null, $password = null, \StructType\UserProfile $userProfile = null, \StructType\RightsProfile $rightsProfile = null)
    {
        $this
            ->setInactive($inactive)
            ->setPersonalCommunication($personalCommunication)
            ->setPersonID($personID)
            ->setPersonExternalCode($personExternalCode)
            ->setLanguage($language)
            ->setDescription($description)
            ->setEmail($email)
            ->setPhone($phone)
            ->setPassword($password)
            ->setUserProfile($userProfile)
            ->setRightsProfile($rightsProfile);
    }
    /**
     * Get Inactive value
     * @return bool
     */
    public function getInactive()
    {
        return $this->Inactive;
    }
    /**
     * Set Inactive value
     * @param bool $inactive
     * @return \StructType\TxConnectDispatcherDetails
     */
    public function setInactive($inactive = null)
    {
        // validation for constraint: boolean
        if (!is_null($inactive) && !is_bool($inactive)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($inactive, true), gettype($inactive)), __LINE__);
        }
        $this->Inactive = $inactive;
        return $this;
    }
    /**
     * Get PersonalCommunication value
     * @return \ArrayType\ArrayOfPersonalCommunicationInsert|null
     */
    public function getPersonalCommunication()
    {
        return $this->PersonalCommunication;
    }
    /**
     * Set PersonalCommunication value
     * @param \ArrayType\ArrayOfPersonalCommunicationInsert $personalCommunication
     * @return \StructType\TxConnectDispatcherDetails
     */
    public function setPersonalCommunication(\ArrayType\ArrayOfPersonalCommunicationInsert $personalCommunication = null)
    {
        $this->PersonalCommunication = $personalCommunication;
        return $this;
    }
    /**
     * Get PersonID value
     * @return string|null
     */
    public function getPersonID()
    {
        return $this->PersonID;
    }
    /**
     * Set PersonID value
     * @param string $personID
     * @return \StructType\TxConnectDispatcherDetails
     */
    public function setPersonID($personID = null)
    {
        // validation for constraint: string
        if (!is_null($personID) && !is_string($personID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($personID, true), gettype($personID)), __LINE__);
        }
        $this->PersonID = $personID;
        return $this;
    }
    /**
     * Get PersonExternalCode value
     * @return string|null
     */
    public function getPersonExternalCode()
    {
        return $this->PersonExternalCode;
    }
    /**
     * Set PersonExternalCode value
     * @param string $personExternalCode
     * @return \StructType\TxConnectDispatcherDetails
     */
    public function setPersonExternalCode($personExternalCode = null)
    {
        // validation for constraint: string
        if (!is_null($personExternalCode) && !is_string($personExternalCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($personExternalCode, true), gettype($personExternalCode)), __LINE__);
        }
        $this->PersonExternalCode = $personExternalCode;
        return $this;
    }
    /**
     * Get Language value
     * @return string|null
     */
    public function getLanguage()
    {
        return $this->Language;
    }
    /**
     * Set Language value
     * @param string $language
     * @return \StructType\TxConnectDispatcherDetails
     */
    public function setLanguage($language = null)
    {
        // validation for constraint: string
        if (!is_null($language) && !is_string($language)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($language, true), gettype($language)), __LINE__);
        }
        $this->Language = $language;
        return $this;
    }
    /**
     * Get Description value
     * @return string|null
     */
    public function getDescription()
    {
        return $this->Description;
    }
    /**
     * Set Description value
     * @param string $description
     * @return \StructType\TxConnectDispatcherDetails
     */
    public function setDescription($description = null)
    {
        // validation for constraint: string
        if (!is_null($description) && !is_string($description)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($description, true), gettype($description)), __LINE__);
        }
        $this->Description = $description;
        return $this;
    }
    /**
     * Get Email value
     * @return string|null
     */
    public function getEmail()
    {
        return $this->Email;
    }
    /**
     * Set Email value
     * @param string $email
     * @return \StructType\TxConnectDispatcherDetails
     */
    public function setEmail($email = null)
    {
        // validation for constraint: string
        if (!is_null($email) && !is_string($email)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($email, true), gettype($email)), __LINE__);
        }
        $this->Email = $email;
        return $this;
    }
    /**
     * Get Phone value
     * @return string|null
     */
    public function getPhone()
    {
        return $this->Phone;
    }
    /**
     * Set Phone value
     * @param string $phone
     * @return \StructType\TxConnectDispatcherDetails
     */
    public function setPhone($phone = null)
    {
        // validation for constraint: string
        if (!is_null($phone) && !is_string($phone)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($phone, true), gettype($phone)), __LINE__);
        }
        $this->Phone = $phone;
        return $this;
    }
    /**
     * Get Password value
     * @return string|null
     */
    public function getPassword()
    {
        return $this->Password;
    }
    /**
     * Set Password value
     * @param string $password
     * @return \StructType\TxConnectDispatcherDetails
     */
    public function setPassword($password = null)
    {
        // validation for constraint: string
        if (!is_null($password) && !is_string($password)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($password, true), gettype($password)), __LINE__);
        }
        $this->Password = $password;
        return $this;
    }
    /**
     * Get UserProfile value
     * @return \StructType\UserProfile|null
     */
    public function getUserProfile()
    {
        return $this->UserProfile;
    }
    /**
     * Set UserProfile value
     * @param \StructType\UserProfile $userProfile
     * @return \StructType\TxConnectDispatcherDetails
     */
    public function setUserProfile(\StructType\UserProfile $userProfile = null)
    {
        $this->UserProfile = $userProfile;
        return $this;
    }
    /**
     * Get RightsProfile value
     * @return \StructType\RightsProfile|null
     */
    public function getRightsProfile()
    {
        return $this->RightsProfile;
    }
    /**
     * Set RightsProfile value
     * @param \StructType\RightsProfile $rightsProfile
     * @return \StructType\TxConnectDispatcherDetails
     */
    public function setRightsProfile(\StructType\RightsProfile $rightsProfile = null)
    {
        $this->RightsProfile = $rightsProfile;
        return $this;
    }
}
